Index: utils/tools/DOMAINcfg/src/domzgr.F90
===================================================================
--- utils/tools/DOMAINcfg/src/domzgr.F90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/domzgr.F90	(revision 14623)
@@ -75,20 +75,10 @@
    REAL(wp) ::   rn_zb_b           !  offset for calculating Zb
 
-  !! * Substitutions
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!                   ***  vectopt_loop_substitute  ***
-   !!----------------------------------------------------------------------
-   !! ** purpose :   substitute the inner loop start/end indices with CPP macro
-   !!                allow unrolling of do-loop (useful with vector processors)
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2014)
-   !! $Id: vectopt_loop_substitute.h90 4990 2014-12-15 16:42:49Z timgraham $ 
-   !! Software governed by the CeCILL licence (./LICENSE)
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3.1 , NEMO Consortium (2011)
-   !! $Id: domzgr.F90 6827 2016-08-01 13:37:15Z flavoni $
-   !! Software governed by the CeCILL licence     (./LICENSE)
+   !! NEMO/OCE 4.0 , NEMO Consortium (2018)
+   !! $Id: dommsk.F90 13305 2020-07-14 17:12:25Z acc $
+   !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS       
@@ -124,11 +114,11 @@
       !
       !
-      REWIND( numnam_ref )              ! Namelist namzgr in reference namelist : Vertical coordinate
+     ! REWIND( numnam_ref )              ! Namelist namzgr in reference namelist : Vertical coordinate
       READ  ( numnam_ref, namzgr, IOSTAT = ios, ERR = 901 )
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namzgr in configuration namelist : Vertical coordinate
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in reference namelist')
+
+     ! REWIND( numnam_cfg )              ! Namelist namzgr in configuration namelist : Vertical coordinate
       READ  ( numnam_cfg, namzgr, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in configuration namelist', lwp )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr in configuration namelist')
       IF(lwm) WRITE ( numond, namzgr )
 
@@ -279,11 +269,11 @@
       CALL iom_get( inum, jpdom_unknown, 'e3w_1d'  , pe3w_1d  )
       !
-      CALL iom_get( inum, jpdom_data, 'e3t_0'  , pe3t  , lrowattr=ln_use_jattr )    ! 3D coordinate
-      CALL iom_get( inum, jpdom_data, 'e3u_0'  , pe3u  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e3v_0'  , pe3v  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e3f_0'  , pe3f  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e3w_0'  , pe3w  , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e3uw_0' , pe3uw , lrowattr=ln_use_jattr )
-      CALL iom_get( inum, jpdom_data, 'e3vw_0' , pe3vw , lrowattr=ln_use_jattr )
+      CALL iom_get( inum, jpdom_global, 'e3t_0'  , pe3t , cd_type = 'T', psgn = 1._wp, kfill = jpfillcopy )    ! 3D coordinate
+      CALL iom_get( inum, jpdom_global, 'e3u_0'  , pe3u , cd_type = 'U', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e3v_0'  , pe3v , cd_type = 'V', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e3f_0'  , pe3f , cd_type = 'F', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e3w_0'  , pe3w , cd_type = 'W', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e3uw_0' , pe3uw, cd_type = 'U', psgn = 1._wp, kfill = jpfillcopy )
+      CALL iom_get( inum, jpdom_global, 'e3vw_0' , pe3vw, cd_type = 'V', psgn = 1._wp, kfill = jpfillcopy )
       !
       !                          !* depths
@@ -297,6 +287,6 @@
          CALL iom_get( inum, jpdom_unknown, 'gdept_1d', pdept_1d )   
          CALL iom_get( inum, jpdom_unknown, 'gdepw_1d', pdepw_1d )
-         CALL iom_get( inum, jpdom_data   , 'gdept_0' , pdept , lrowattr=ln_use_jattr )
-         CALL iom_get( inum, jpdom_data   , 'gdepw_0' , pdepw , lrowattr=ln_use_jattr )
+         CALL iom_get( inum, jpdom_global , 'gdept_0' , pdept, kfill = jpfillcopy )
+         CALL iom_get( inum, jpdom_global , 'gdepw_0' , pdepw, kfill = jpfillcopy )
          !
       ELSE                                !- depths computed from e3. scale factors
@@ -312,7 +302,7 @@
       !
       !                          !* ocean top and bottom level
-      CALL iom_get( inum, jpdom_data, 'top_level'    , z2d  , lrowattr=ln_use_jattr )   ! 1st wet T-points (ISF)
+      CALL iom_get( inum, jpdom_global, 'top_level'    , z2d )   ! 1st wet T-points (ISF)
       k_top(:,:) = NINT( z2d(:,:) )
-      CALL iom_get( inum, jpdom_data, 'bottom_level' , z2d  , lrowattr=ln_use_jattr )   ! last wet T-points
+      CALL iom_get( inum, jpdom_global, 'bottom_level' , z2d )   ! last wet T-points
       k_bot(:,:) = NINT( z2d(:,:) )
       !
@@ -660,10 +650,8 @@
          mbathy(:,:) = 0                                   ! set to zero extra halo points
          bathy (:,:) = 0._wp                               ! (require for mpp case)
-         DO jj = 1, nlcj                                   ! interior values
-            DO ji = 1, nlci
+         DO_2D( 0, 0, 0, 0 )
                mbathy(ji,jj) = idta( mig(ji), mjg(jj) )
                bathy (ji,jj) = zdta( mig(ji), mjg(jj) )
-            END DO
-         END DO
+         END_2D
          risfdep(:,:)=0.e0
          misfdep(:,:)=1
@@ -677,5 +665,5 @@
          IF( ln_zco )   THEN                          ! zco : read level bathymetry 
             CALL iom_open ( cn_topolvl, inum )  
-            CALL iom_get  ( inum, jpdom_data, cn_bathlvl, bathy )
+            CALL iom_get  ( inum, jpdom_auto, cn_bathlvl, bathy )
             CALL iom_close( inum )
             mbathy(:,:) = INT( bathy(:,:) )
@@ -715,5 +703,5 @@
             IF( ntopo == 1) THEN
                CALL iom_open ( cn_topo, inum ) 
-               CALL iom_get  ( inum, jpdom_data, cn_bath, bathy, lrowattr=ln_use_jattr  )
+               CALL iom_get  ( inum, jpdom_auto, cn_bath, bathy )
                CALL iom_close( inum )
             ELSE
@@ -735,5 +723,5 @@
             IF ( ln_isfcav ) THEN
                CALL iom_open ( cn_fisfd, inum ) 
-               CALL iom_get  ( inum, jpdom_data, cn_visfd, risfdep )
+               CALL iom_get  ( inum, jpdom_auto, cn_visfd, risfdep )
                CALL iom_close( inum )
             END IF
@@ -857,21 +845,13 @@
       ENDIF
       !                                          ! East-west cyclic boundary conditions
+
       IF( jperio == 0 ) THEN
          IF(lwp) WRITE(numout,*) ' mbathy set to 0 along east and west boundary: jperio = ', jperio
-         IF( lk_mpp ) THEN
-            IF( nbondi == -1 .OR. nbondi == 2 ) THEN
-               IF( jperio /= 1 )   mbathy(1,:) = 0
-            ENDIF
-            IF( nbondi == 1 .OR. nbondi == 2 ) THEN
-               IF( jperio /= 1 )   mbathy(nlci,:) = 0
-            ENDIF
+         IF( ln_zco .OR. ln_zps ) THEN
+           mbathy(  mi0(     1+nn_hls):mi1(     1+nn_hls),:) = 0
+           mbathy(  mi0(jpiglo-nn_hls):mi1(jpiglo-nn_hls),:) = 0
          ELSE
-            IF( ln_zco .OR. ln_zps ) THEN
-               mbathy( 1 ,:) = 0
-               mbathy(jpi,:) = 0
-            ELSE
-               mbathy( 1 ,:) = jpkm1
-               mbathy(jpi,:) = jpkm1
-            ENDIF
+           mbathy(  mi0(     1+nn_hls):mi1(     1+nn_hls),:) = jpkm1
+           mbathy(  mi0(jpiglo-nn_hls):mi1(jpiglo-nn_hls),:) = jpkm1
          ENDIF
       ELSEIF( l_Iperio ) THEN
@@ -898,5 +878,6 @@
       ! Number of ocean level inferior or equal to jpkm1
       zbathy(:,:) = FLOAT( mbathy(:,:) )
-      ikmax = glob_max( 'domzgr', zbathy(:,:) )
+      ikmax = MAXVAL(zbathy(:,:))
+      CALL mpp_max( 'domzgr',ikmax)
 
       IF( ikmax > jpkm1 ) THEN
@@ -1308,11 +1289,11 @@
       ALLOCATE( zenv(jpi,jpj), ztmp(jpi,jpj), zmsk(jpi,jpj), zri(jpi,jpj), zrj(jpi,jpj), zhbat(jpi,jpj) , ztmpi1(jpi,jpj), ztmpi2(jpi,jpj), ztmpj1(jpi,jpj), ztmpj2(jpi,jpj) )
       !
-      REWIND( numnam_ref )              ! Namelist namzgr_sco in reference namelist : Sigma-stretching parameters
+      !REWIND( numnam_ref )              ! Namelist namzgr_sco in reference namelist : Sigma-stretching parameters
       READ  ( numnam_ref, namzgr_sco, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_sco in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namzgr_sco in configuration namelist : Sigma-stretching parameters
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_sco in reference namelist')
+
+      !REWIND( numnam_cfg )              ! Namelist namzgr_sco in configuration namelist : Sigma-stretching parameters
       READ  ( numnam_cfg, namzgr_sco, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_sco in configuration namelist', lwp )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzgr_sco in configuration namelist')
       IF(lwm) WRITE ( numond, namzgr_sco )
 
@@ -1386,5 +1367,5 @@
 
       ! apply lateral boundary condition   CAUTION: keep the value when the lbc field is zero
-      CALL lbc_lnk( 'domzgr',zenv, 'T', 1._wp, 'no0' )
+      CALL lbc_lnk( 'domzgr',zenv, 'T', 1._wp, kfillmode=jpfillnothing )
       ! 
       ! smooth the bathymetry (if required)
@@ -1417,15 +1398,12 @@
          ! we could exit DO WHILE prematurely before checking r-value
          ! of current zenv
-         DO jj = 1, nlcj
-            DO ji = 1, nlci
+          DO_2D( 0, 0, 0, 0 )
                zrmax = MAX( zrmax, ABS(zri(ji,jj)), ABS(zrj(ji,jj)) )
-            END DO
-         END DO
+         END_2D
          zri(:,:) = 0._wp
          zrj(:,:) = 0._wp
-         DO jj = 1, nlcj
-            DO ji = 1, nlci
-               iip1 = MIN( ji+1, nlci )      ! force zri = 0 on last line (ji=ncli+1 to jpi)
-               ijp1 = MIN( jj+1, nlcj )      ! force zrj = 0 on last raw  (jj=nclj+1 to jpj)
+          DO_2D( 0, 0, 0, 0 )
+               iip1 = MIN( ji+1, jpi )      ! force zri = 0 on last line (ji=ncli+1 to jpi)
+               ijp1 = MIN( jj+1, jpj )      ! force zrj = 0 on last raw  (jj=nclj+1 to jpj)
                IF( (zenv(ji,jj) > 0._wp) .AND. (zenv(iip1,jj) > 0._wp)) THEN
                   zri(ji,jj) = ( zenv(iip1,jj  ) - zenv(ji,jj) ) / ( zenv(iip1,jj  ) + zenv(ji,jj) )
@@ -1438,17 +1416,14 @@
                IF( zrj(ji,jj) >  rn_rmax )   ztmpj1(ji  ,jj  ) = zenv(ji  ,ijp1) * zrfact
                IF( zrj(ji,jj) < -rn_rmax )   ztmpj2(ji  ,ijp1) = zenv(ji  ,jj  ) * zrfact
-            END DO
-         END DO
+         END_2D
   !       IF( lk_mpp )   CALL mpp_max( zrmax )   ! max over the global domain
          !
          IF(lwp)WRITE(numout,*) 'zgr_sco :   iter= ',jl, ' rmax= ', zrmax
          !
-         DO jj = 1, nlcj
-            DO ji = 1, nlci
+         DO_2D( 0, 0, 0, 0 )
                zenv(ji,jj) = MAX(zenv(ji,jj), ztmpi1(ji,jj), ztmpi2(ji,jj), ztmpj1(ji,jj), ztmpj2(ji,jj) )
-            END DO
-         END DO
+         END_2D
          ! apply lateral boundary condition   CAUTION: keep the value when the lbc field is zero
-         CALL lbc_lnk( 'toto',zenv, 'T', 1._wp, 'no0' )
+         CALL lbc_lnk( 'toto',zenv, 'T', 1._wp, kfillmode=jpfillnothing)
          !                                                  ! ================ !
       END DO                                                !     End loop     !
Index: utils/tools/DOMAINcfg/src/errioipsl.f90
===================================================================
--- utils/tools/DOMAINcfg/src/errioipsl.f90	(revision 14606)
+++ utils/tools/DOMAINcfg/src/errioipsl.f90	(revision 14623)
@@ -1,3 +1,4 @@
 MODULE errioipsl
+!$AGRIF_DO_NOT_TREAT
 !-
 !$Id: errioipsl.f90 2281 2010-10-15 14:21:13Z smasson $
@@ -213,3 +214,4 @@
 !===
 !-------------------
+!$AGRIF_END_DO_NOT_TREAT
 END MODULE errioipsl
